saveProjectAs('IkerMAQ_motor.FLU')

#! Wed Dec 01 17:04:17 CET 2021 loadProject('E:/SimLab/Multiphysics/IkerMAQ/1_Flux/MotorMode/IkerMAQ_motor.FLU')

#! Tue Dec 07 14:04:33 CET 2021 loadProject('E:/SimLab/Multiphysics/IkerMAQ/1_Flux/MotorMode/IkerMAQ_MotorSolved.FLU')

EvolutiveCurve2D(name='EvolutiveCurve2D_1',
                 evolutivePath=EvolutivePath(parameterSet=[SetParameterXVariable(paramEvol=VariationParameter['ANGPOS_ROTOR'],
                                                                                 limitMin=0.0,
                                                                                 limitMax=78.0)]),
                 formula=['TorqueElecMag(ROTOR)'])

ImportFluxCurve2DFromTxtFile(fileName='../ProjectFromFM/test1207/fromFM.txt')

VariationCurveSuperimposition(name='SuperimpositionCurve',
                              interpolation='linear',
                              variationCurves=[Curve2d['EVOLUTIVECURVE2D_1'],
                                               Curve2d['EVOLUTIVECURVE2D_1_IMPORT_1']])

saveProject()

#! Thu Dec 09 10:09:00 CET 2021 loadProject('E:/SimLab/Multiphysics/IkerMAQ/1_Flux/MotorMode/IkerMAQ_MotorModeSolved.FLU')

Curve2d['SUPERIMPOSITIONCURVE'].visible=0

Curve2d['EVOLUTIVECURVE2D_1_IMPORT_1'].visible=0

CurveVariation2D[ALL].delete()
EvolutiveCurve2D(name='Torque_Ori',
                 evolutivePath=EvolutivePath(parameterSet=[SetParameterXVariable(paramEvol=VariationParameter['ANGPOS_ROTOR'],
                                                                                 limitMin=0.0,
                                                                                 limitMax=78.0)]),
                 formula=['TorqueElecMag(ROTOR)'])

ImportFluxCurve2DFromTxtFile(fileName='../ProjectFromFM/testTheta/Curves/Torque_31_6.txt')

ImportFluxCurve2DFromTxtFile(fileName='../ProjectFromFM/testTheta/Curves/Torque_38_0.txt')

ImportFluxCurve2DFromTxtFile(fileName='../ProjectFromFM/testTheta/Curves/Torque_42_0.txt')

VariationCurveSuperimposition(name='SuperimpositionCurve',
                              interpolation='linear',
                              variationCurves=[Curve2d['TORQUE_31_6_IMPORT_1'],
                                               Curve2d['TORQUE_38_0_IMPORT_1'],
                                               Curve2d['TORQUE_42_IMPORT_1'],
                                               Curve2d['TORQUE_ORI']])

saveProject()

#! Wed Apr 27 18:26:25 CEST 2022 loadProject('E:/SimLab/Multiphysics/IkerMAQ/1_Flux/MotorMode/IkerMAQ_MotorModeSolved.FLU')

saveProjectAs('../../../../CFD/IkerMAQ/1_Flux/IkerMAQ_MotorMode_Solved.FLU')

#! Wed May 18 20:18:00 CEST 2022 loadProject('E:/SimLab/CFD/IkerMAQ/1_Flux/IkerMAQ_MotorMode_Solved.FLU')

CurveVariation2D[ALL].delete()
startMacroTransaction()
ComputePhysicTransient['ComputePhysic'].storageName='ComputePhysic_1'

ComputePhysicTransient['ComputePhysic'].formula=['PjouleCC(PHA)',
                                                 'PjouleCC(PHB)',
                                                 'PjouleCC(PHC)']

endMacroTransaction()

saveProjectAs('../../Release/IkerMAQ/1_Flux/IkerMAQ_MotorMode_Solved.FLU')

#! Thu May 19 10:55:30 CEST 2022 loadProject('E:/SimLab/CFD/Release/IkerMAQ/1_Flux/IkerMAQ_MotorMode_Solved.FLU')

DeleteAllResults(deletePostprocessingResults='yes')

exportCircuit(filename='IkerMAQ_MotorMode_Solved_log1.xcir')

storeCircuitLinks()

DeleteElectricCircuit(deleteStrandedConductor='YES')

importCircuit(filename='IkerMAQ_MotorMode_Solved_log1.xcir',
              importValue=1,
              ImportFELink=1)


restoreCircuitLinks()

RegionFace['MAGNET_N'].magneticTransient2D=MagneticTransient2DFaceSolidConductor(material=Material['MAGNET_NDFEB'],
                                                                                 circuitType=Circuit(orientation=PositiveOrientation(),
                                                                                                     component=SolidConductor2Terminals['SOLIDCONDUCTOR2TERMINALS_1']))


RegionFace['MAGNET_S1'].magneticTransient2D=MagneticTransient2DFaceSolidConductor(material=Material['MAGNET_NDFEB'],
                                                                                  circuitType=Circuit(orientation=PositiveOrientation(),
                                                                                                      component=SolidConductor2Terminals['SOLIDCONDUCTOR2TERMINALS_2']))


RegionFace['MAGNET_S2'].magneticTransient2D=MagneticTransient2DFaceSolidConductor(material=Material['MAGNET_NDFEB'],
                                                                                  circuitType=Circuit(orientation=PositiveOrientation(),
                                                                                                      component=SolidConductor2Terminals['SOLIDCONDUCTOR2TERMINALS_3']))


saveProjectAs('IkerMAQ_MotorMode_ForCFD.FLU')

orientRegSurfMaterial(region=RegionFace['MAGNET_N'],coordSys=CoordSys['XY1'],orientation='Direction',angle='36')
orientRegSurfMaterial(region=RegionFace['MAGNET_S1'],coordSys=CoordSys['XY1'],orientation='Direction',angle='180')
orientRegSurfMaterial(region=RegionFace['MAGNET_S2'],coordSys=CoordSys['XY1'],orientation='Direction',angle='72+180')
saveProjectAs('IkerMAQ_MotorMode_ForCFD.FLU')

#! Fri Jun 10 16:32:41 CEST 2022 loadProject('E:/SimLab/CFD/Release/IkerMAQ/1_Flux/IkerMAQ_MotorMode_ForCFD_Solved.FLU')

CurveVariation2D[ALL].delete()
RegionFace['STATOR','ROTOR'].color=Color['Grey_Steel']


RegionFace['SHAFT'].color=Color['Grey_Aluminium']


RegionFace['MAGNET_N'].color=Color['Orange_Corail']


RegionFace['MAGNET_S1','MAGNET_S2'].color=Color['Orange_Light']


startMacroTransaction()
RegionFace['AP'].color=Color['Red']

RegionFace['AN'].color=Color['Red_Dark']

RegionFace['CP'].color=Color['Blue']

RegionFace['CN'].color=Color['Blue_Dark']

RegionFace['BN'].color=Color['Green_Dark2']

RegionFace['BP'].color=Color['Green']

endMacroTransaction()

RegionFace['AIR','AIRGAP_ROTOR','AIRGAP_STATOR','TESTING_COIL_N','TESTING_COIL_P','WEDGE'].color=Color['Blue_Light']


RegionFace['INFINITE'].color=Color['Blue_Light']


saveProjectAs('../../../IkerMAQ_CFD/3_Flux/LossComputationCFD/IkerMAQ_MotorMode_Solved.FLU')

#! Wed Jun 29 11:56:02 CEST 2022 loadProject('E:/SimLab/CFD/IkerMAQ_CFD/0_Release/eMotorCFD_IkerMAQ/1_Flux/IkerMAQ_MotorMode_Solved.FLU')

DeleteAllResults(deletePostprocessingResults='yes')

saveProjectAs('IkerMAQ_MotorMode.FLU')

