#! Flux2D 21.2
#! Tue Nov 30 17:41:04 CET 2021 loadProject('E:/AlejandroRodriguez/Flux_In_Action/21_11_30_IkerMAQ_MotorMode/IkerMAQ_motor.FLU')

startMacroTransaction()
RegionFace['MAGNET_N'].magneticTransient2D=MagneticTransient2DFaceMagnetic(material=Material['MAGNET_NDFEB'])

RegionFace['MAGNET_S1'].magneticTransient2D=MagneticTransient2DFaceMagnetic(material=Material['MAGNET_NDFEB'])

RegionFace['MAGNET_S2'].magneticTransient2D=MagneticTransient2DFaceMagnetic(material=Material['MAGNET_NDFEB'])

endMacroTransaction()

saveProject()

#! Tue Nov 30 18:02:09 CET 2021 loadProject('IkerMAQ_motor.FLU')
Find_Rotor_Angle_2D(NPPoles=5.0,
                    NPPolesRep=1.0,
                    StatorPeriodicity=5.0,
                    CurrentSupply=[CurrentSource['I_PHA'],
                                   CurrentSource['I_PHB'],
                                   CurrentSource['I_PHC']],
                    Rotor=MechanicalSet['ROTOR'],
                    Stator=MechanicalSet['STATOR'])

DeleteAllResults(deletePostprocessingResults='yes')

saveProject()

orientRegSurfMaterial(region=RegionFace['MAGNET_N'],coordSys=CoordSys['XY1'],orientation='Direction',angle='36')
orientRegSurfMaterial(region=RegionFace['MAGNET_S1'],coordSys=CoordSys['XY1'],orientation='Direction',angle='180')
orientRegSurfMaterial(region=RegionFace['MAGNET_S2'],coordSys=CoordSys['XY1'],orientation='Direction',angle='72+180')
saveProject()

#! Tue Nov 30 18:14:10 CET 2021 loadProject('E:/AlejandroRodriguez/Flux_In_Action/21_11_30_IkerMAQ_MotorMode/IkerMAQ_motor.FLU')

lastInstance = VariationParameterPilot(name='IPK',
                        referenceValue=1.0)

lastInstance = VariationParameterPilot(name='THETA : Current angle',
                        referenceValue=0.0)

VariationParameter['THETA'].name='THETA : Current phase'


VariationParameter['IPK'].name='IPK : Peak current'


lastInstance = VariationParameterFormula(name='I1',
                          formula='1')

lastInstance = VariationParameterFormula(name='FREQ : Electric frequency',
                          formula='SPEED/60*5')

startMacroTransaction()
VariationParameter['I1'].formula='IPK*cos(2*pi()*FREQ+THETA*pi()/180)'

VariationParameter['I1'].name='IA'

endMacroTransaction()

lastInstance = VariationParameterFormula(name='IB',
                          formula='IPK*Cos(2*Pi()*FREQ+THETA*Pi()/180-2*pi()/3)')

lastInstance = VariationParameterFormula(name='IC',
                          formula='IPK*Cos(2*Pi()*FREQ+THETA*Pi()/180+2*Pi()/3)')

loadMacro(fileName='C:/Program Files/Altair/2021.2/flux/Extensions/Macros/Macros_Flux2D_Postproc/Find_Rotor_Angle_2D.PFM')


saveProject()

exportCircuit(filename='IkerMAQ_motor_log1.xcir')

storeCircuitLinks()

DeleteElectricCircuit(deleteStrandedConductor='YES')

importCircuit(filename='IkerMAQ_motor_log1.xcir',
              importValue=1,
              ImportFELink=1)


restoreCircuitLinks()

displayArrowsOnMagnet()

deleteArrows()

saveProject()

#! Tue Nov 30 18:15:56 CET 2021 loadProject('E:/AlejandroRodriguez/Flux_In_Action/21_11_30_IkerMAQ_MotorMode/IkerMAQ_motor.FLU')

saveProject()

exportCircuit(filename='IkerMAQ_motor_log1.xcir')

storeCircuitLinks()

DeleteElectricCircuit(deleteStrandedConductor='YES')

importCircuit(filename='IkerMAQ_motor_log1.xcir',
              importValue=1,
              ImportFELink=1)


restoreCircuitLinks()

saveProject()

#! Tue Nov 30 18:32:41 CET 2021 loadProject('E:/AlejandroRodriguez/Flux_In_Action/21_11_30_IkerMAQ_MotorMode/IkerMAQ_motor.FLU')

VariationParameter['IA'].formula='IPK*Cos(2*Pi()*FREQ*TIME+THETA*Pi()/180)'


VariationParameter['IB'].formula='IPK*Cos(2*Pi()*FREQ*TIME+THETA*Pi()/180-2*Pi()/3)'


VariationParameter['IC'].formula='IPK*Cos(2*Pi()*FREQ*TIME+THETA*Pi()/180+2*Pi()/3)'


saveProject()

#! Tue Nov 30 18:38:44 CET 2021 loadProject('E:/AlejandroRodriguez/Flux_In_Action/21_11_30_IkerMAQ_MotorMode/IkerMAQ_motor.FLU')

VariationParameter['IPK'].referenceValue=125.86


startMacroTransaction()
Scenario['NORMAL_CONDITIONS'].addPilot(pilot=MultiValues(parameter=VariationParameter['THETA'],
                                                         intervals=[IntervalStepValue(minValue=-15.0,
                                                                                      maxValue=15.0,
                                                                                      stepValue=2.5)]))
Scenario['NORMAL_CONDITIONS'].pilots['ANGPOS_ROTOR']=MultiValues(parameter=VariationParameter['ANGPOS_ROTOR'],
                                                                 intervals=[IntervalStepValue(minValue=0.0,
                                                                                              maxValue=22.0,
                                                                                              stepValue=2.0)])
Scenario['NORMAL_CONDITIONS'].name='TEST_CONTROL_ANGLE'
endMacroTransaction()

saveProject()

Scenario['TEST_CONTROL_ANGLE'].solve(projectName='test_ctrol_angle.FLU')

DeleteAllResults(deletePostprocessingResults='yes')

startMacroTransaction()
Scenario['TEST_CONTROL_ANGLE'].pilots['THETA']=MultiValues(parameter=VariationParameter['THETA'],
                                                           intervals=[IntervalStepValue(minValue=0.0,
                                                                                        maxValue=355.0,
                                                                                        stepValue=5.0)])
endMacroTransaction()

Scenario['TEST_CONTROL_ANGLE'].solve(projectName='test_ctrol_angle.FLU')

Macro['FIND_ROTOR_ANGLE_2D'].unload()
loadMacro(fileName='C:/Program Files/Altair/2021.2/flux/Extensions/Macros/ExtractFrom3DCurve.PFM')

EvolutiveCurve3D(name='EvolutiveCurve3D_1',
                 evolutivePath=EvolutivePath(parameterSet=[SetParameterYVariable(paramEvol=VariationParameter['THETA'],
                                                                                 limitMin=0.0,
                                                                                 limitMax=355.0),
                                                           SetParameterXVariable(paramEvol=VariationParameter['ANGPOS_ROTOR'],
                                                                                 limitMin=0.0,
                                                                                 limitMax=22.0)]),
                 formula=['TorqueElecMag(ROTOR)'])

Curve3d['EVOLUTIVECURVE3D_1'].visible=0

ExtractFrom3DCurve(curve3D=Curve3d['EVOLUTIVECURVE3D_1'],
                   axe=VariationParameter['THETA'],
                   analyseCurve='MEAN')

Curve2d['EVOLUTIVECURVE3D_1_MEAN'].visible=0

CurveVariation3D['EVOLUTIVECURVE3D_1'].delete()
EvolutiveCurve3D(name='EvolutiveCurve3D_1',
                 evolutivePath=EvolutivePath(parameterSet=[SetParameterYVariable(paramEvol=VariationParameter['THETA'],
                                                                                 limitMin=0.0,
                                                                                 limitMax=355.0),
                                                           SetParameterXVariable(paramEvol=VariationParameter['ANGPOS_ROTOR'],
                                                                                 limitMin=4.0,
                                                                                 limitMax=22.0)]),
                 formula=['TorqueElecMag(ROTOR)'])

ExtractFrom3DCurve(curve3D=Curve3d['EVOLUTIVECURVE3D_1'],
                   axe=VariationParameter['THETA'],
                   analyseCurve='MEAN')

VariationParameter['THETA'].referenceValue=340.0


340-47

340+47-360

(390+280)/2

(380+290)/2

VariationParameter['THETA'].referenceValue=335.0


335-45

335+45-360

DeleteAllResults(deletePostprocessingResults='yes')

result = VariationParameter['THETA'].type()
startMacroTransaction()
Scenario['TEST_CONTROL_ANGLE'].pilots['THETA']=MultiValues(parameter=VariationParameter['THETA'],
                                                           intervals=[IntervalStepValue(minValue=330.0,
                                                                                        maxValue=355.0,
                                                                                        stepValue=1.0)])
endMacroTransaction()

Scenario['TEST_CONTROL_ANGLE'].solve(projectName='test_ctrol_angle.FLU')

EvolutiveCurve3D(name='EvolutiveCurve3D_1',
                 evolutivePath=EvolutivePath(parameterSet=[SetParameterYVariable(paramEvol=VariationParameter['THETA'],
                                                                                 limitMin=330.0,
                                                                                 limitMax=354.0),
                                                           SetParameterXVariable(paramEvol=VariationParameter['ANGPOS_ROTOR'],
                                                                                 limitMin=4.0,
                                                                                 limitMax=22.0)]),
                 formula=['TorqueElecMag(ROTOR)'])

ExtractFrom3DCurve(curve3D=Curve3d['EVOLUTIVECURVE3D_1'],
                   axe=VariationParameter['THETA'],
                   analyseCurve='MEAN')

VariationParameter['THETA'].referenceValue=338.0


DeleteAllResults(deletePostprocessingResults='yes')

Scenario(name='WORKING_POINT')

startMacroTransaction()

Scenario['WORKING_POINT'].addPilot(pilot=MultiValues(parameter=VariationParameter['ANGPOS_ROTOR'],
                                                     intervals=[IntervalStepValue(minValue=0.0,
                                                                                  maxValue=92.0,
                                                                                  stepValue=2.0)]))

Scenario['WORKING_POINT'].addPilot(pilot=MultiValues(parameter=VariationParameter['THETA'],
                                                     intervals=[IntervalStepValue(minValue=-47.0,
                                                                                  maxValue=47.0,
                                                                                  stepValue=94.0)]))

endMacroTransaction()

Scenario['WORKING_POINT'].solve(projectName='test_ctrol_angle.FLU')

338-47

338+47-360

DeleteAllResults(deletePostprocessingResults='yes')

360-291

startMacroTransaction()
Scenario['WORKING_POINT'].pilots['THETA']=MultiValues(parameter=VariationParameter['THETA'],
                                                      intervals=[IntervalStepValue(minValue=-69.0,
                                                                                   maxValue=25.0,
                                                                                   stepValue=94.0)])
endMacroTransaction()

Scenario['WORKING_POINT'].solve(projectName='test_ctrol_angle.FLU')

EvolutiveCurve2D(name='EvolutiveCurve2D_1',
                 evolutivePath=EvolutivePath(parameterSet=[SetParameterFixed(paramEvol=VariationParameter['THETA'],
                                                                             currentValue=25.0),
                                                           SetParameterXVariable(paramEvol=VariationParameter['ANGPOS_ROTOR'],
                                                                                 limitMin=0.0,
                                                                                 limitMax=92.0)]),
                 formula=['U(PHA)',
                          'FluxCoil(PHA)',
                          'U(PHB)',
                          'FluxCoil(PHB)',
                          'U(PHC)',
                          'FluxCoil(PHC)'])

Curve2d['EVOLUTIVECURVE2D_1'].visible=0

EvolutiveCurve2D(name='EvolutiveCurve2D_2',
                 evolutivePath=EvolutivePath(parameterSet=[SetParameterFixed(paramEvol=VariationParameter['THETA'],
                                                                             currentValue=25.0),
                                                           SetParameterXVariable(paramEvol=VariationParameter['ANGPOS_ROTOR'],
                                                                                 limitMin=0.0,
                                                                                 limitMax=92.0)]),
                 formula=['U(TESTING_COIL_CONDUCTOR)',
                          'FluxCoil(TESTING_COIL_CONDUCTOR)'])

EvolutiveCurve2D(name='EvolutiveCurve2D_3',
                 evolutivePath=EvolutivePath(parameterSet=[SetParameterFixed(paramEvol=VariationParameter['THETA'],
                                                                             currentValue=25.0),
                                                           SetParameterXVariable(paramEvol=VariationParameter['ANGPOS_ROTOR'],
                                                                                 limitMin=4.0,
                                                                                 limitMax=92.0)]),
                 formula=['U(TESTING_COIL_CONDUCTOR)',
                          'FluxCoil(TESTING_COIL_CONDUCTOR)'])

EvolutiveCurve2D(name='EvolutiveCurve2D_4',
                 evolutivePath=EvolutivePath(parameterSet=[SetParameterFixed(paramEvol=VariationParameter['THETA'],
                                                                             currentValue=-69.0),
                                                           SetParameterXVariable(paramEvol=VariationParameter['ANGPOS_ROTOR'],
                                                                                 limitMin=4.0,
                                                                                 limitMax=92.0)]),
                 formula=['U(TESTING_COIL_CONDUCTOR)',
                          'FluxCoil(TESTING_COIL_CONDUCTOR)'])



Curve2d['EVOLUTIVECURVE2D_2'].visible=0

EvolutiveCurve2D(name='EvolutiveCurve2D_5',
                 evolutivePath=EvolutivePath(parameterSet=[SetParameterFixed(paramEvol=VariationParameter['THETA'],
                                                                             currentValue=25.0),
                                                           SetParameterXVariable(paramEvol=VariationParameter['ANGPOS_ROTOR'],
                                                                                 limitMin=4.0,
                                                                                 limitMax=92.0)]),
                 formula=['U(PHA)',
                          'I(PHA)'])

EvolutiveCurve2D(name='EvolutiveCurve2D_6',
                 evolutivePath=EvolutivePath(parameterSet=[SetParameterFixed(paramEvol=VariationParameter['THETA'],
                                                                             currentValue=25.0),
                                                           SetParameterXVariable(paramEvol=VariationParameter['ANGPOS_ROTOR'],
                                                                                 limitMin=20.0,
                                                                                 limitMax=92.0)]),
                 formula=['U(PHA)',
                          'I(PHA)'])

result = SpectrumAnalysis(curve=Curve2d['EVOLUTIVECURVE2D_6'],
                 component='U(PHA)',
                 cycle=FullCycle(),
                 numberHarmonics=12,
                 computeDCComponent=NonContinue(),
                 scaleDecibel=FirstHarmonic(firstHarmonicValue=100.0),
                 nameRebuiltCurve='Extrapolated_curve',
                 nameFourierTransform='Spectrum')

Curve2d['EXTRAPOLATED_CURVE'].visible=0


result = SpectrumAnalysis(curve=Curve2d['EVOLUTIVECURVE2D_6'],
                 component='I(PHA)',
                 cycle=FullCycle(),
                 numberHarmonics=12,
                 computeDCComponent=NonContinue(),
                 scaleDecibel=FirstHarmonic(firstHarmonicValue=100.0),
                 nameRebuiltCurve='Extrapolated_curve',
                 nameFourierTransform='Spectrum')


Curve2d['EVOLUTIVECURVE2D_6'].visible=0

Curve2d['EVOLUTIVECURVE2D_4'].visible=0

Curve2d['EVOLUTIVECURVE2D_5'].visible=0

Curve2d['EXTRAPOLATED_CURVE1'].visible=0

Curve2d['SPECTRUM1'].visible=0

Curve2d['SPECTRUM'].visible=0

Curve2d['EVOLUTIVECURVE2D_3'].visible=0

DeleteAllResults(deletePostprocessingResults='yes')

startMacroTransaction()
Scenario['WORKING_POINT'].pilots['ANGPOS_ROTOR']=MultiValues(parameter=VariationParameter['ANGPOS_ROTOR'],
                                                             intervals=[IntervalStepValue(minValue=0.0,
                                                                                          maxValue=78.0,
                                                                                          stepValue=2.0)])
Scenario['WORKING_POINT'].pilots['THETA']=MultiValues(parameter=VariationParameter['THETA'],
                                                      intervals=[IntervalStepValue(minValue=25.0,
                                                                                   maxValue=35.0,
                                                                                   stepValue=10.0)])
endMacroTransaction()

Scenario['WORKING_POINT'].solve(projectName='test_ctrol_angle.FLU')

EvolutiveCurve2D(name='EvolutiveCurve2D_1',
                 evolutivePath=EvolutivePath(parameterSet=[SetParameterFixed(paramEvol=VariationParameter['THETA'],
                                                                             currentValue=35.0),
                                                           SetParameterXVariable(paramEvol=VariationParameter['ANGPOS_ROTOR'],
                                                                                 limitMin=0.0,
                                                                                 limitMax=78.0)]),
                 formula=['U(PHA)',
                          'I(PHA)'])

Curve2d['EVOLUTIVECURVE2D_1'].visible=0

EvolutiveCurve2D(name='EvolutiveCurve2D_2',
                 evolutivePath=EvolutivePath(parameterSet=[SetParameterFixed(paramEvol=VariationParameter['THETA'],
                                                                             currentValue=25.0),
                                                           SetParameterXVariable(paramEvol=VariationParameter['ANGPOS_ROTOR'],
                                                                                 limitMin=6.0,
                                                                                 limitMax=78.0)]),
                 formula=['U(PHA)',
                          'I(PHA)'])

result = SpectrumAnalysis(curve=Curve2d['EVOLUTIVECURVE2D_1'],
                 component='U(PHA)',
                 cycle=FullCycle(),
                 numberHarmonics=12,
                 computeDCComponent=NonContinue(),
                 scaleDecibel=FirstHarmonic(firstHarmonicValue=100.0),
                 nameRebuiltCurve='Extrapolated_curve',
                 nameFourierTransform='Spectrum')

Curve2d['EXTRAPOLATED_CURVE'].visible=0

Curve2d['SPECTRUM'].visible=0

result = SpectrumAnalysis(curve=Curve2d['EVOLUTIVECURVE2D_2'],
                 component='U(PHA)',
                 cycle=FullCycle(),
                 numberHarmonics=12,
                 computeDCComponent=NonContinue(),
                 scaleDecibel=FirstHarmonic(firstHarmonicValue=100.0),
                 nameRebuiltCurve='Extrapolated_curve',
                 nameFourierTransform='Spectrum')


result = SpectrumAnalysis(curve=Curve2d['EVOLUTIVECURVE2D_2'],
                 component='I(PHA)',
                 cycle=FullCycle(),
                 numberHarmonics=12,
                 computeDCComponent=NonContinue(),
                 scaleDecibel=FirstHarmonic(firstHarmonicValue=100.0),
                 nameRebuiltCurve='Extrapolated_curve',
                 nameFourierTransform='Spectrum')


EvolutiveCurve2D(name='EvolutiveCurve2D_3',
                 evolutivePath=EvolutivePath(parameterSet=[SetParameterFixed(paramEvol=VariationParameter['THETA'],
                                                                             currentValue=35.0),
                                                           SetParameterXVariable(paramEvol=VariationParameter['ANGPOS_ROTOR'],
                                                                                 limitMin=6.0,
                                                                                 limitMax=78.0)]),
                 formula=['TorqueElecMag(ROTOR)'])

Scenario['WORKING_POINT'].continueToSolve(projectName='test_ctrol_angle.FLU',
                                          option='IterateOnNonConvergentSteps')

CurveVariation2D[ALL].delete()
EvolutiveCurve2D(name='Test_Coil',
                 evolutivePath=EvolutivePath(parameterSet=[SetParameterFixed(paramEvol=VariationParameter['THETA'],
                                                                             currentValue=35.0),
                                                           SetParameterXVariable(paramEvol=VariationParameter['ANGPOS_ROTOR'],
                                                                                 limitMin=6.0,
                                                                                 limitMax=78.0)]),
                 formula=['U(TESTING_COIL_CONDUCTOR)',
                          'FluxCoil(TESTING_COIL_CONDUCTOR)'])

DeleteAllResults(deletePostprocessingResults='yes')

338+57

338-360-57

startMacroTransaction()
Scenario['WORKING_POINT'].pilots['THETA']=MultiValues(parameter=VariationParameter['THETA'],
                                                      intervals=[IntervalStepValue(minValue=-79.0,
                                                                                   maxValue=35.0,
                                                                                   stepValue=114.0)])
endMacroTransaction()

Scenario['WORKING_POINT'].solve(projectName='test_ctrol_angle.FLU')

EvolutiveCurve2D(name='PH_A',
                 evolutivePath=EvolutivePath(parameterSet=[SetParameterFixed(paramEvol=VariationParameter['THETA'],
                                                                             currentValue=-79.0),
                                                           SetParameterXVariable(paramEvol=VariationParameter['ANGPOS_ROTOR'],
                                                                                 limitMin=6.0,
                                                                                 limitMax=78.0)]),
                 formula=['U(PHA)',
                          'I(PHA)'])

result = SpectrumAnalysis(curve=Curve2d['PH_A'],
                 component='U(PHA)',
                 cycle=FullCycle(),
                 numberHarmonics=12,
                 computeDCComponent=NonContinue(),
                 scaleDecibel=FirstHarmonic(firstHarmonicValue=100.0),
                 nameRebuiltCurve='Extrapolated_curve',
                 nameFourierTransform='Spectrum')

result = SpectrumAnalysis(curve=Curve2d['PH_A'],
                 component='I(PHA)',
                 cycle=FullCycle(),
                 numberHarmonics=12,
                 computeDCComponent=NonContinue(),
                 scaleDecibel=FirstHarmonic(firstHarmonicValue=100.0),
                 nameRebuiltCurve='Extrapolated_curve',
                 nameFourierTransform='Spectrum')



EvolutiveCurve2D(name='EvolutiveCurve2D_1',
                 evolutivePath=EvolutivePath(parameterSet=[SetParameterFixed(paramEvol=VariationParameter['THETA'],
                                                                             currentValue=35.0),
                                                           SetParameterXVariable(paramEvol=VariationParameter['ANGPOS_ROTOR'],
                                                                                 limitMin=0.0,
                                                                                 limitMax=78.0)]),
                 formula=['U(TESTING_COIL_CONDUCTOR)/5',
                          'FluxCoil(TESTING_COIL_CONDUCTOR)/5'])

Curve2d['EVOLUTIVECURVE2D_1'].visible=0

EvolutiveCurve2D(name='Test_coil',
                 evolutivePath=EvolutivePath(parameterSet=[SetParameterFixed(paramEvol=VariationParameter['THETA'],
                                                                             currentValue=-79.0),
                                                           SetParameterXVariable(paramEvol=VariationParameter['ANGPOS_ROTOR'],
                                                                                 limitMin=6.0,
                                                                                 limitMax=78.0)]),
                 formula=['U(TESTING_COIL_CONDUCTOR)/5',
                          'FluxCoil(TESTING_COIL_CONDUCTOR)/5'])

DeleteAllResults(deletePostprocessingResults='yes')

startMacroTransaction()
Scenario['WORKING_POINT'].pilots['THETA']=MonoValue(parameter=VariationParameter['THETA'],
                                                    value=-83.0)
endMacroTransaction()

Scenario['WORKING_POINT'].solve(projectName='test_ctrol_angle.FLU')

EvolutiveCurve2D(name='PHA',
                 evolutivePath=EvolutivePath(parameterSet=[SetParameterFixed(paramEvol=VariationParameter['THETA'],
                                                                             currentValue=-83.0),
                                                           SetParameterXVariable(paramEvol=VariationParameter['ANGPOS_ROTOR'],
                                                                                 limitMin=6.0,
                                                                                 limitMax=78.0)]),
                 formula=['U(PHA)',
                          'I(PHA)'])

result = SpectrumAnalysis(curve=Curve2d['PHA'],
                 component='U(PHA)',
                 cycle=FullCycle(),
                 numberHarmonics=12,
                 computeDCComponent=NonContinue(),
                 scaleDecibel=FirstHarmonic(firstHarmonicValue=100.0),
                 nameRebuiltCurve='Extrapolated_curve',
                 nameFourierTransform='Spectrum')

result = SpectrumAnalysis(curve=Curve2d['PHA'],
                 component='I(PHA)',
                 cycle=FullCycle(),
                 numberHarmonics=12,
                 computeDCComponent=NonContinue(),
                 scaleDecibel=FirstHarmonic(firstHarmonicValue=100.0),
                 nameRebuiltCurve='Extrapolated_curve',
                 nameFourierTransform='Spectrum')




DeleteAllResults(deletePostprocessingResults='yes')

startMacroTransaction()
Scenario['WORKING_POINT'].pilots['THETA']=MonoValue(parameter=VariationParameter['THETA'],
                                                    value=35.0)
endMacroTransaction()

Scenario['TEST_CONTROL_ANGLE'].solve(projectName='test_ctrol_angle.FLU')

DeleteAllResults(deletePostprocessingResults='yes')

Scenario['WORKING_POINT'].solve(projectName='test_ctrol_angle.FLU')

EvolutiveCurve2D(name='EvolutiveCurve2D_1',
                 evolutivePath=EvolutivePath(parameterSet=[SetParameterFixed(paramEvol=VariationParameter['THETA'],
                                                                             currentValue=35.0),
                                                           SetParameterXVariable(paramEvol=VariationParameter['ANGPOS_ROTOR'],
                                                                                 limitMin=6.0,
                                                                                 limitMax=78.0)]),
                 formula=['U(PHA)',
                          'U(IA)'])

result = SpectrumAnalysis(curve=Curve2d['EVOLUTIVECURVE2D_1'],
                 component='U(PHA)',
                 cycle=FullCycle(),
                 numberHarmonics=12,
                 computeDCComponent=NonContinue(),
                 scaleDecibel=FirstHarmonic(firstHarmonicValue=100.0),
                 nameRebuiltCurve='Extrapolated_curve',
                 nameFourierTransform='Spectrum')

DeleteAllResults(deletePostprocessingResults='yes')

exportCircuit(filename='test_ctrol_angle_log1.xcir')

storeCircuitLinks()

DeleteElectricCircuit(deleteStrandedConductor='YES')

importCircuit(filename='test_ctrol_angle_log1.xcir',
              importValue=1,
              ImportFELink=1)


restoreCircuitLinks()

VariationParameterPilot['L_LOAD'].delete()
VariationParameterPilot['R_LOAD'].delete()
saveProject()

lastInstance = VariationParameterFormula(name='UPHA',
                          formula='U(PHA)')

startMacroTransaction()
Scenario['WORKING_POINT'].pilots['THETA']=MultiValues(parameter=VariationParameter['THETA'],
                                                      intervals=[IntervalStepValue(minValue=25.0,
                                                                                   maxValue=35.0,
                                                                                   stepValue=1.0)])
endMacroTransaction()

Scenario['WORKING_POINT'].solve(projectName='test_ctrol_angle.FLU')

EvolutiveCurve3D(name='V_PH',
                 evolutivePath=EvolutivePath(parameterSet=[SetParameterYVariable(paramEvol=VariationParameter['THETA'],
                                                                                 limitMin=25.0,
                                                                                 limitMax=35.0),
                                                           SetParameterXVariable(paramEvol=VariationParameter['ANGPOS_ROTOR'],
                                                                                 limitMin=6.0,
                                                                                 limitMax=78.0)]),
                 formula=['U(PHA)'])

EvolutiveCurve3D(name='Torque',
                 evolutivePath=EvolutivePath(parameterSet=[SetParameterYVariable(paramEvol=VariationParameter['THETA'],
                                                                                 limitMin=25.0,
                                                                                 limitMax=35.0),
                                                           SetParameterXVariable(paramEvol=VariationParameter['ANGPOS_ROTOR'],
                                                                                 limitMin=6.0,
                                                                                 limitMax=78.0)]),
                 formula=['TorqueElecMag(ROTOR)'])

ExtractFrom3DCurve(curve3D=Curve3d['TORQUE'],
                   axe=VariationParameter['THETA'],
                   analyseCurve='MEAN')

ExtractFrom3DCurve(curve3D=Curve3d['V_PH'],
                   axe=VariationParameter['THETA'],
                   analyseCurve='RMS')

VariationParameter['THETA'].referenceValue=31.6


DeleteAllResults(deletePostprocessingResults='yes')

startMacroTransaction()
Scenario['WORKING_POINT'].removePilot(parameter=VariationParameter['THETA'])
Scenario['WORKING_POINT'].pilots['ANGPOS_ROTOR']=MultiValues(parameter=VariationParameter['ANGPOS_ROTOR'],
                                                             intervals=[IntervalStepValue(minValue=0.0,
                                                                                          maxValue=78.0,
                                                                                          stepValue=1.0)])
endMacroTransaction()

Scenario['WORKING_POINT'].solve(projectName='test_ctrol_angle.FLU')

saveProject()

saveProject()

DeleteAllResults(deletePostprocessingResults='yes')

Scenario['TEST_CONTROL_ANGLE'].delete()
