#! Flux2D 22.1

startMacroTransaction()
ComputePhysicTransient['ComputePhysic'].storageName='Winding_Losses'

ComputePhysicTransient['ComputePhysic'].formula=['PjouleCC(PHA)',
                                                 'PjouleCC(PHB)',
                                                 'PjouleCC(PHC)',
                                                 'PjouleCC(PHA)+PjouleCC(PHB)+PjouleCC(PHC)']

endMacroTransaction()

lastInstance = ComputePhysic(name='Winding_Losses_1', formula=['PjouleCC(PHA)', 'PjouleCC(PHB)', 'PjouleCC(PHC)', 'PjouleCC(PHA)+PjouleCC(PHB)+PjouleCC(PHC)'])

startMacroTransaction()
ComputePhysicTransient['ComputePhysic'].storageName='Magnet_Losses'

ComputePhysicTransient['ComputePhysic'].formula=['PjouleSC(SOLIDCONDUCTOR2TERMINALS_1)',
                                                 'PjouleSC(SOLIDCONDUCTOR2TERMINALS_2)',
                                                 'PjouleSC(SOLIDCONDUCTOR2TERMINALS_3)']

endMacroTransaction()

lastInstance = ComputePhysic(name='Magnet_Losses_1', formula=['PjouleSC(SOLIDCONDUCTOR2TERMINALS_1)', 'PjouleSC(SOLIDCONDUCTOR2TERMINALS_2)', 'PjouleSC(SOLIDCONDUCTOR2TERMINALS_3)'])

result = IronLossesRegion(faceRegions=[RegionFace['STATOR']],
                 timeInterval=EvolutivePath(parameterSet=[SetParameterXVariable(paramEvol=VariationParameter['ANGPOS_ROTOR'],
                                                                                limitMin=6.0,
                                                                                limitMax=78.0)]),
                 curveName='CURVE_LOSS_REGION_STATOR',
                 resultName='LOSSES_IN_REGION_STATOR',
                 lossSpatialParameterName='DVOL_LOSS_MEAN_STATOR',
                 energySpatialParameterName='DVOL_ENERGY_LOSS_STATOR',
                 periodicity=FullCycleIronLosses(),
                 sheetLossModel=CaseLSpredefined(lsSheetModel=LsSheetIronM80065A()))

result = IronLossesRegion(faceRegions=[RegionFace['ROTOR']],
                 timeInterval=EvolutivePath(parameterSet=[SetParameterXVariable(paramEvol=VariationParameter['ANGPOS_ROTOR'],
                                                                                limitMin=6.0,
                                                                                limitMax=78.0)]),
                 curveName='CURVE_LOSS_REGION_ROTOR',
                 resultName='LOSSES_IN_REGION_ROTOR',
                 lossSpatialParameterName='DVOL_LOSS_MEAN_ROTOR',
                 energySpatialParameterName='DVOL_ENERGY_LOSS_ROTOR',
                 periodicity=FullCycleIronLosses(),
                 sheetLossModel=CaseLSpredefined(lsSheetModel=LsSheetIronM80065A()))

saveProjectAs('IkerMAQ_GlobalLossValue.FLU')

openIODataContext(subtype='Generic')

lastInstance = VolumeDataSupport(name='DataSupport_Rotor',
                  aspect='mesh',
                  visibility=Visibility['VISIBLE'],
                  color=Color['Turquoise'],
                  entities2d=FaceRegionSupport2D(faceRegion=[RegionFace['ROTOR']]),
                  extrusion=Extruded(numberOfElement=2),
                  fullDevice='no')

lastInstance = VolumeDataSupport(name='DATASUPPORT_STATOR',
                  aspect='mesh',
                  visibility=Visibility['VISIBLE'],
                  color=Color['Turquoise'],
                  entities2d=FaceRegionSupport2D(faceRegion=[RegionFace['STATOR']]),
                  extrusion=Extruded(numberOfElement=2),
                  fullDevice='no')

lastInstance = GenericDataCollection(name='DataCollection_ROTOR',
                      support=DataSupport['DATASUPPORT_ROTOR'],
                      formula='DVOL_LOSS_MEAN_ROTOR',
                      valuesType=ElementValues(),
                      interval=CurrentStep())

lastInstance = GenericDataCollection(name='DATACOLLECTION_STATOR',
                      support=DataSupport['DATASUPPORT_STATOR'],
                      formula='DVOL_LOSS_MEAN_STATOR',
                      valuesType=ElementValues(),
                      interval=CurrentStep())

lastInstance = StaticHeatAcusolveDataExport(name='DataExport_Rotor_Losses',
                             filename='IkerMAQ_CFD_RotorLosses',
                             collection=CollectionForAcusolveStaticHeatDensityExport['DATACOLLECTION_ROTOR'])

lastInstance = StaticHeatAcusolveDataExport(name='DATAEXPORT_STATOR_LOSSES',
                             filename='IkerMAQ_CFD_StatorLosses',
                             collection=CollectionForAcusolveStaticHeatDensityExport['DATACOLLECTION_STATOR'])

CurveVariation2D['CURVE_LOSS_REGION_STATOR','CURVE_LOSS_REGION_ROTOR'].exportTXT(txtFile='result/TestCase_RES',
          mode='replace')


saveProjectAs('IkerMAQ_NodalLossMapping.FLU')